﻿//////////////////////////////////////////////
// SsaoProgramTracker.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Forward decl -----------------------------

namespace nkGraphics
{
	class Program ;
}

/// Includes ---------------------------------

// nkAstraeus
#include "../../Utils/ProgramTracker.h"

#include "SsaoEffectInfo.h"

// nkCommon
#include <nilkinsCommon/Patterns/SingletonClass.h>

/// Internals --------------------------------

namespace nkAstraeus
{
	struct SsaoProgramIdGenerator
	{
		static unsigned long long generate (const SsaoEffectInfo& info) ;
	} ;

	struct SsaoProgramNameGenerator
	{
		constexpr static const char* name = "NILKINS_SSAO_PROGRAM_" ;
	} ;
}

/// Class ------------------------------------

namespace nkAstraeus
{
	class SsaoProgramTracker final : public ProgramTracker<SsaoEffectInfo, SsaoProgramIdGenerator, SsaoProgramNameGenerator>, public nkCommon::SingletonClass<SsaoProgramTracker>
	{
		friend class SingletonClass<SsaoProgramTracker> ;

		private :

			// Functions
			// Constructor, destructor
			SsaoProgramTracker () ;
			~SsaoProgramTracker () ;
	} ;
}