﻿//////////////////////////////////////////////
// MeshDataLinkTracker.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Forward decl -----------------------------

namespace nkGraphics
{
	class Mesh ;
	class SubEntity ;
}

/// Includes ---------------------------------

// nkCommon
#include <nilkinsCommon/Patterns/SingletonClass.h>

// Standards
#include <unordered_map>
#include <unordered_set>

/// Class ------------------------------------

namespace nkGraphics
{
	class MeshDataLinkTracker final : public nkCommon::SingletonClass<MeshDataLinkTracker>
	{
		friend class nkCommon::SingletonClass<MeshDataLinkTracker> ;

		private :

			// Attributes
			// Mémoire tracking
			std::unordered_map<Mesh*, std::unordered_set<SubEntity*>> _links ;

		private :

			// Functions
			// Constructeur, destructeur
			MeshDataLinkTracker () ;
			~MeshDataLinkTracker () ;

		public :

			// Management mémoire
			void addLink (Mesh* mesh, SubEntity* subEnt) ;
			void removeLink (Mesh* mesh, SubEntity* subEnt) ;

			// Utilities
			void onMeshUpdatedBounds (Mesh* mesh) ;
	} ;
}