﻿//////////////////////////////////////////////
// Slider.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Includes ---------------------------------

// nkWinUi
#include "Component.h"

#include "../Dll/DllDefines.h"

// Standards
#include <functional>

/// Class ------------------------------------

namespace nkWinUi
{
	class DLL_WINUI_EXPORT Slider : public Component
	{
		protected :

			// Attributes
			std::function<bool(Slider*,  float)> _valueChangeCallback ;

			float _min ;
			float _max ;
			float _current ;

		public :
		
			// Constructor, destructor
			Slider () ;
			~Slider () ;

			// Getters
			float getMin () const ;
			float getMax () const ;
			float getCurrent () const ;
			std::function<bool(Slider*, float)> getValueChangeCallback () const ;

			// Setters
			virtual void setMin (float value) ;
			virtual void setMax (float value) ;
			virtual void setCurrent (float value) ;
			virtual void setValueChangeCallback (const std::function<bool(Slider*, float)>& callback) ;

			// Import / Export
			virtual void exportIntrospection (nkExport::Node* rootNode) override ;
			virtual void importClassFromTree (nkExport::Node* rootNode) override ;
	} ;
}